[regression] scale/spread: "Initiate Window Picker for All Windows" does not show all windows. It shows only windows from current workspace.

Bug #933776 reported by Žilvinas on 2012-02-16
This bug affects 252 people
Affects Status Importance Assigned to Milestone
Ayatana Design
Undecided
Wujinnnnn
Compiz
Medium
Łukasz Zemczak
Compiz Core
Medium
Łukasz Zemczak
compiz (Ubuntu)
High
Unassigned
Precise
High
Unassigned

Bug Description

[Test Case]
1. Open few applications on workspace 1
2. Open a few more applications on workspace 2
3. Press the shortcut for 'initiate window picker for all windows' (Super+W by default)
   -> Verify that the scale plugin shows windows from both workspaces, not only from one of them

4. To verify, press the shortcut for 'initiate window picker' (Shift+Alt+UpArrow by default)
   -> Verify that the scale plugin only shows windows from the current workspace

[Regression Potential]
No real regression potential, in the impossible case the scale plugin might stop working

Original description:

compiz expo plugin have the option to change the scale plugin behavior but that does not work unity Unity..

1. start ccsm, go to scale plugin, go to bindings tab
2. see 'initiate window picker for all window' is enabled

What happen:
that setting is being overridden by Unity since super+w only shows windows from current workspace.

--------------------------------------------
Desired resolution:

- As the change request conflicts with bug #689733 , the current default behaviour of the spread should not change. Also significant changes to Ubuntu's default behaviour should not be made in a SRU.

- In the medium term this functionality will be replaced by 'The Spread'. See http://design.canonical.com/2012/03/task-switching-in-ubuntu-and-a-introduction-to-the-spread/ and also http://design.canonical.com/the-toolkit/unity-task-switching/ for more details. Please discuss feedback on these designs in the comments of the design blog post linked to above that announced this feature.

- In the short term what we can do is expose this option in 'System Settings / Keyboard / Shortcuts'. We can add two new actions to this panel:

'Spread all windows on the current workspace' (default setting: Super+W)
and
'Spread all windows on all workspaces' (default setting: Disabled)

and then it will be easy for users to choose the behaviour that suites them best.

Related branches

Žilvinas (zilvinas-urbon) wrote :
Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in compiz (Ubuntu):
status: New → Confirmed
zzecool (zzecool) wrote :

I can confirm this Super + W instead of "initiate window picker for all windows" reacts like

"initiate windows picker" for current workspace .

zzecool (zzecool) on 2012-02-16
summary: - Compiz Scale Addon "All Windows" not working
+ "Super + W" Compiz Scale Addon "All Windows" not working
summary: - "Super + W" Compiz Scale Addon "All Windows" not working
+ "Super + W" window picker only shows local windows, not all.
zzecool (zzecool) on 2012-02-18
Changed in compiz-core:
status: New → Confirmed
Changed in ayatana-design:
status: New → Confirmed
Omer Akram (om26er) on 2012-02-20
summary: - "Super + W" window picker only shows local windows, not all.
+ Unity overrides compiz scale plugin behavior settings
description: updated
affects: ayatana-design → unity
Omer Akram (om26er) on 2012-02-20
Changed in compiz-core:
importance: Undecided → Low
Changed in compiz (Ubuntu):
importance: Undecided → Low
Changed in unity:
importance: Undecided → Low

Also affects me on Precise Beta 1, compiz 0.9.7.0.

Dave Conniff (chronniff) wrote :

yeah, I can confirm I have this issue too on the beta 1 updated to date.....I really hope this is a bug and not just because the unity developers decided that this functionality is the best, because as small a bug as this may appear, its kind of a deal breaker for me using the new unity, I use the scale plugin for all windows as a go to shortcut in my work flow, and trying to do anything without it right now is extremely frustrating and slow

zzecool (zzecool) wrote :

This is a bug other than Unity team decide to use this behavior as the default.

In the CCSM manager there are 4 different ways to initiate the picker - scale plugin

#1: initiate the picker on the current workspace . Default shortcut : shift + alt + up

#2: initiate the picker for all windows ( meaning from every workspace ) . Default shortcut : Super + W

#3: initiate the picker for windows group . Default shortcut : non

#4: initiate the picker for the current output . Default shortcut : non

The mistake here is that the unity team instead of change the default shortcut for the 1st way from "shift + alt +up" ---> "Super +W" they change the behavior of the 2nd way to act like the 1st.

So what we have now is #1 and #2 acting exactly the same , only picking windows from the current workspace which is wrong as we have lost the ability to initiate the picker for "all windows"

This bug is also producing side effects in other functions. I had a weird experience today, where I had two windows for the same app open. (chrome) One was minimised while the other was not. When I clicked the icon, expecting to see scale of both windows or at least a window and an icon (for the minimised window). I got scale for the active window only and show desktop was initiated. I thought I'd "lost" all my desktop widgets. It took me a few minutes to figure it out as I never use show desktop because it doesn't respect the desktop setting on my widgets. For the sake of completeness my widgets consist on conky and screenlets both of witch have a desktop setting.

To add to that the only way I could get the minimised window back was with alt-tab

Michael Weimann (m982) wrote :

Same here using the current 12.04 Beta.

Initialize scaling for all windows only shows the windows on the current workspace.

Also seems to affect Expo plugin settings. I typically have Scale set to show windows from all workspaces when mouse pointer goes to bottom right corner, and expo activates on bottom-left corner. Also, I enable Scale-Addons. I can manually set all of these things, and they work until I restart X. My guess is that some Unity configuration replaces all of my Compiz settings.

PS - Running on 11.10, newest 295.33 Nvidia drivers from PPA

Matthias Niess (mniess) wrote :

Wow. This is really bad. There seem to be many strange side-effects. Copy and pasting from #971927 here is another:

1. open two terminals on two seperate workspaces
2. minimize the terminal on the second workspace
3. on a third workspace click the terminal-icon on the launcher.

It will take you to the non-minimized terminal. The only way to find the minimized terminal is by either remembering the workspace on which you minimized it or by checking the small triangle to the left of the terminal icon on every workspace. So this also breaks the application spread behavior.

Dave Conniff (chronniff) wrote :

I would love to see at least a little attention given to this. At least assign someone to this, and its importance at least deserves a medium....I mean this is exactly the sort of thing that has put everyone off of unity in the first place

shafin (mahdee-jameel) wrote :

This bug also affects scale hot corners - when any hot corner is assigned to reveal all windows in all worspaces, only windows from the present workspace are shown instead.

This greatly affects my workflow as scale was a swift way to swich between workspaces, now I have to activate workspace switcher for that.

Andreas Zeller (luxmedien) wrote :

It's not only a bug in unity. I am using LXDE and I am having the same issue. Also hot corner.

WANGXiao (wangxiao1254) wrote :

I went back to 11.10 just because of this bug. It really affects the productivity.

Matthias Niess (mniess) wrote :

I guess this behavior is wanted. But can the person who did this please point at what they changed so that we can run our own patched version of compiz? I really have problems finding open windows on other desktops again.

Also: wasn't the expected bahavior of the unity launcher that when I click an icon it shows me all open windows of that application? If it doesn't do that, why bother at all?

Danillo (danillo) wrote :

This is not a wanted behavior, and it could not be because of the reasons in comment #6. If you look at http://design.canonical.com/the-toolkit/unity-task-switching/ you'll confirm it, and if you check the activity above, you'll see that the developers have confirmed this bug. It just hasn't been fixed yet because its importance was set to low, as there are even more urgent and crucial bugs at the moment. As soon as they fix them, they'll turn to this one. We just have to be patient.

Remember what they did with the Alt-Tab: we now have a key combo for changing windows on the current workspace only, and another one for changing windows on all workspaces (Ctrl+Alt+Tab). I've always changed Ctrl+Shift+Up for Super+E to have a key to scale windows from the current workspace only and another for all windows, and it works great. I'm guessing we'll have something like that.

Bruno Santos (bsantos) wrote :

I don't think it's Unity overriding the behavior, just the behavior that it's broken.

If Unity would override the shortcut for showing all windows for just showing those on the current workspace, we could still use a different shortcut for showing all windows, and that doesn't work either.

Changing the behavior of the showing all windows to just showing those on the current workspace when such a behavior is already available wouldn't make any sense, since if that would be the intended default behavior, just the shortcuts would need to be changed.

Although now the shortcut help screen says that the shortcut defined in the scale plugin for all windows is to spread windows in the current workspace, so it may be Unity overriding the behavior after all... hope not. :-(

The windows of each workspace are seen flying around, so they are being restored to their original workspace instead of the active one.

Feras Al-Taher (ftaher) wrote :

Using the CompizConfig Settings Manager, I am setting the binding for( Initiate Window Picker) to one of the hot corners. This setting gets reset whenever I restart Ubuntu. So, when ever I boot in to my desktop, I need to set the binding again to ( Initiate Window Picker For All Windows) instead. and things work beautifully.

Wonder if you could fix this bug. so that Unity ( or what ever ) does not override this setting.

Neil Broadley (scaine) wrote :

This bug affects non-minimised windows too. Open two terminals, on different workspaces, click the "dash" button for your terminal and nothing will happen, because it only sees that one terminal.

Worse, if you're on a workspace on which you haven't opened a terminal, pressing the "dash" button for your terminal will pop you to one of the two workspaces that has a terminal, ignoring the other non-mimised terminal in the other workspace.

Bruno Santos (bsantos) wrote :

Feras, are your ccsm options all messed up too? Now the options just show their variable names instead of the description of the option... And there are missing options, window resize doesn't have the kind of resizing any more, for example.

If I set the binding in ccsm I still get the wrong behavior, it shows the windows on the current workspace and not all windows as expected.

gunwald (gunwald) wrote :

Is there any hope that this bug gets fixed soon? The scale plugin is the most important Compiz function. Would be nice to know whether or not this get fixed or we have to wait until the edge of doom. In this case I would prefer to prepare myself to change to Gnome-Shell...

Andreas Zeller (luxmedien) wrote :

Unfortunately, that's not gonna solve your problem. I am on LXDE and the behavior is exactly the same. They messed it up somewhere in compiz. This is not a unity-issue.

Bence Lukács (lukacs-bence1) wrote :

@luxmedien Yes, it may be a compiz bug, but gnome-shell doesn't use compiz...

Bruno Santos (bsantos) wrote :

Maybe we should update the description of this bug, since this is a problem with compiz and not unity?

Is the scale plugin used by so few people that this is considered a low priority bug? I can't use this plugin at all, or at least it complicates having applications spread across various workspaces.

summary: - Unity overrides compiz scale plugin behavior settings
+ behavior for compiz scale plugin all window picker is wrong

@ Bruno Yes it a compiz bug, since it affects scale even while not using unity. However, Unity is relying on the scale plugin as part of it window management strategy. Since the broken behavior is a direct result of changes made to support that reliance and fixing it would drastically improve window management within Unity. I'd say this bug is Unity's responsibly as well. The problem here is that Unity is moving away from using scale to handle window management. They are planing on making the "spread" functionality part of Unity itself. So there really is no incentive to fix what they broke unless we can convince them this is really bad to leave unfixed in an LTS release.

Bruno Santos (bsantos) wrote :

What I don't understand is why would they change the behavior of the all window picker if there's a just picker for the current workspace. It would make more sense to just default to have Super + w a shortcut for that function instead. Is 71 people finding this behavior a bug, enough?

Maybe Daniel van Vugt can tell us what changes may be be behind this?

aljazek (aljazek) wrote :

One day until LTS release and this bug is still present. Any news? I am also experiencing some flickers while changing workspaces.

Dave Conniff (chronniff) wrote :

well hopefully once its released, this bug report will become so popular that they can't ignore it anymore

Silvio Bierman (sbierman) wrote :

Can we vote for this bug somewhere? It is ridiculous that this was set to low prio since it completely cripples Unity. Single viewport switching is a non-function because switching by definition involves all viewports. The scale plugin if working properly is THE essential function that makes Unity tolerable. Makes you wonder if the guys who forced Unity on us use it themselves...

If this is not fixed by Monday I will switch back to 11.10. I am the experimental 12.04 switcher for my company and will most certainly hold back the rest or they will eat me alive!

Dave Conniff (chronniff) wrote :

I agree with silvio. Unity is actually shaping up quite nicely I have to admit, however its doing so at the expense of the rest of compiz. I'm sure I'm not alone in saying that the only reason I didn't go for a different desktop when unity was forced on us, was because its the only desktop that it didn't do away with the compiz plugins that I have come to absolutely rely on, well so much for that now. If this isn't sorted out soon, my laptop is going gnome-shell, and my desktop is going kde, and most iikely out of spite neither will be on top of ubuntu.

They must be racing to fix any other critical bugs right now. I think we
should try to wait a bit longer to see what can be done to solve this. I
think this issue may be worse than it looks from related bug reports and
experience. Have you had windows sometimes fly out of the workspace? I even
have been getting invisible windows after this happens! Windows focused but
that flew away from the current workspace and are nowhere to be found and
cannot be recovered (maybe they stopped being painted?)?

This is certainly being looked for by one of the devs soon (or so I hope),
but there's probably so much they can do when a release was just published.
I'd prefer to have some feedback from the devs, but not if it is at cost of
develop time.

This bug is a major issue for me too (even more if the windows disappear
and I can't see them to save my work!), but lets try to be a bit more
patient.

this is the most annoying regression I have with 12.04, even the shortcut tip that appears when you hold win key says " 'win+w' spreads windows in current workspace ", does this mean it's intended behavior? why?

James Heany (digphan) wrote :

I upgraded to 12.04 LTS on release day (April 26th) and this is the first problem I noticed. window picker confined to current workspace, not all. Also, edge assigned to window picker gets reset every boot and I have to go in and reassigned it again after every boot.

It is a very aggravating bug when one is so use to using the feature and it's now broken.

summary: - behavior for compiz scale plugin all window picker is wrong
+ Super+W shows only windows from curent workspace
summary: - Super+W shows only windows from curent workspace
+ [regression] Super+W shows only windows from curent workspace
Changed in unity:
milestone: none → 5.14.0
Changed in compiz-core:
milestone: none → 0.9.8.0
importance: Low → Medium
Changed in unity:
importance: Low → Medium
Changed in compiz (Ubuntu):
importance: Low → Medium
Changed in compiz-core:
status: Confirmed → Triaged
Changed in compiz (Ubuntu):
status: Confirmed → Triaged
Changed in compiz (Ubuntu Precise):
importance: Undecided → Medium
status: New → Triaged

Affecting my work efficience as well... was so used to it.. please fix it asap

Sebastien Bacher (seb128) wrote :

that bug has been confirmed, targetted for precise and milestoned, it will be worked soon.

The unity team worked hard to get precise out and is get a deserved w.e off work so no need to keep adding "me too" or "asap" comments, those are not useful.

Please keep the bug tracker useful and use the "this bug affects me too" at the top of the page to say it affects you rather than adding extra comments generating emails for all subscribers

summary: - [regression] Super+W shows only windows from curent workspace
+ [regression] Super+W ("Initiate Window Picker for All Windows") shows
+ only windows from curent workspace

while I appreciate that this bug is finally getting the attention it deserves. That description is wrong. The scale "Initiate Window Picker for All Windows" function is completely broken. It isn't just super+w, it just doesn't work with any trigger method or attempting to reassign the shortcut. Try it yourself or read the comments in this bug.

Daniel van Vugt (vanvugt) wrote :

Corey, I know it's broken for all methods. There is a good reason to mention "Super+W" in the description however. That is so other people reporting and triaging the same issue will find this bug more easily instead of creating duplicates.

Doug McMahon (mc3man) wrote :

At the time of this change it seemed to be specially done in scale.cpp. May have been around the time the l. click on icon was changed to current output only, was quite some time ago.
As seen in the attached file which reverts & for better or worse (better here), allows bindings for both current & all to work
(also allows the use of window group from all outputs though not directly thru the scale plugin, that's a different issue since natty

Silvio Bierman (sbierman) wrote :

When was left click on icon changed to current output only? In my 11.10 this worked fine until I upgraded to 12.04.

In my opinion such a modification would be a mistake. As I said earlier I think single output switching is at best the second option for switching between application windows. I for one NEVER want this behaviour. In fact, I only switch outputs manually to start new applications because I have the scale plugin for switching to existing windows.

Like most people I am not a keyboard-shortcut user so the left mouse click is what I use. I really really hope that this becomes optional in some way.

gareth (garethbaxter) wrote :

@Corey Kearney is right, this is not a key binding issue. Both functions do the same thing no matter how you initiate them.

Daniel Kondor (kondor-dani) wrote :

I seem to be experiencing the same bug on a fresh install of Ubuntu 12.04. What I noticed is that I can actually switch to windows on other workspaces without seeing them. For example if I have a terminal on one workspace, and a browser on other, and press Super+A (that is the keyboard shortcut that I assigned to 'show windows from all workspaces') then I can only see the terminal from the current workspace, and it is "selected". However, if I press the 'left' key, the terminal gets "unselected" and the --invisible-- browser on the other workspace probably gets somehow selected; if I then press 'return', then it switches to the workspace with the browser, which also gets focused. This does not happen with the 'show windows from the current workspace', which works as expected. I hope this helps; should I attach additional information (apport report)?

Note: I am not using Unity, I have a GNOME desktop with cairo-dock (i.e. gnome-session, nautilus and compiz but no panels).

So annyoing. Is there a workaround for this over two month old bug?

Youbantu (youbantu) wrote :

Ubuntu 12.04, 64Bit, nvidea GPU, Gnome classic

I have the same problem described in the first mail (above). I have chosen "initiate all windows" which gets active as soon as the mouse is in the lower right corner. Result: Only the windows of the active workspace are shown. Sometimes, there are even some graphic problems (white screen etc.), when I activate the first time for instance.

Youbantu (youbantu) wrote :

... sorry, me again: I agree with Mr Sanitz and many others: It is really annoying to loose a feature that was once SO USEFUL! Please, put "Importance" onto "VERY HIGH" such that it gets fixed soon. Thanks.

This bug will require a fix upstream and downstream...

Upstream: Make sure all windows are shown for the "all windows" bindings.
Downstream: Move the Super+W shortcut from "Initiate Window Picker For All Windows" into "Initiate Window Picker"

summary: - [regression] Super+W ("Initiate Window Picker for All Windows") shows
- only windows from curent workspace
+ [regression] "Initiate Window Picker for All Windows" does not show all
+ windows. It shows only windows from curent workspace.

...where do i find the scale.cpp file to fix the scale plugin with the mentioned workaround?????

Buz Finork (m321v123m) wrote :

One way to get the scale.cpp would be to open a terminal and apt-get source "name of package that has the scale plugin"
that can be found in synaptic, it then downloads the source in the current directory usially ~/

Faibistes (faibistes) wrote :

Having this bug around since february is ridiculous. Isn't there any workaround? Ubuntu is getting more and more insane with every release since Unity.

Bruno Santos (bsantos) wrote :

Thanks for the patch Doug!

pltxtra (pltxtra) wrote :

I just downloaded the source for the compiz-plugins-default package, applied Dougs patch and compiled the scale plugin. (I had to install quite some dependencies to get cmake to stop complaining... ) Basically - the patch works.. Would be nice with an officially fixed package though...

Mark Mandel (mark-mandel) wrote :

Someone needs to make my lazyweb, and write a bash script to do all that ;)

Thanks for the patch too - I should give it a shot.

Probably better if somebody shares his .deb.

Thanks,

-- Alex.
On 10 May 2012 09:35, "Mark Mandel" <email address hidden> wrote:

> Someone needs to make my lazyweb, and write a bash script to do all that
> ;)
>
> Thanks for the patch too - I should give it a shot.
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/933776
>
> Title:
> [regression] "Initiate Window Picker for All Windows" does not show
> all windows. It shows only windows from curent workspace.
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/compiz-core/+bug/933776/+subscriptions
>

Is anyone on this? Upstream? If not I'll take Doughs patch tonight and push it upstream and another patch to fix the key bindings that will go to the compiz-plugin package.

@matt please do, there are to many deps, No one has taken responsibility for this since it was reported in February. You can count me in the lazyweb category for this one too. :)

aljazek (aljazek) wrote :

Yes, please do! That will be a life saver :)

Matthias Niess (mniess) wrote :

@corey: Actually the dependencies don't matter. I'll just branch the upstream compiz code, apply the patch, put my branch on launchpad and submit a merge proposal. Launchpad is really awesome in how easy it makes participation.

Working on Ubuntu packages is a bit more difficult. I'll have to find the package where the default key bindings are set (I'm pretty sure I already know where to look), create a patch and put that patch into the quilt system for the package. I've messed this up countless times, so we'll have to see :-) But addings Doughs patch should be quickly done. I'll be at home in 6 hours and do it!

They matter to me. I don't want to download all the crap necessary to build compiz and plugins. See LAZY. ;)

Matthias Niess (mniess) wrote :

@Corey: This is not a discussion forum. But as I said, you don't need to install the dependencies. If you're interested in such stuff check out the Ubuntu packaging documentation. When I test the fixed package it will be automatically built by pbuilder in a chroot environment (so your own system is not affected). When the test is successful I'll just run "bzr lp-propose" and the fixes are sent to the compiz developers for review.

Cson (theceason) wrote :

11.10 → 12.04
initiate the picker for all windows → initiate the picker

Bruno Santos (bsantos) wrote :

I built compiz with Doug's patch on my ppa:
https://launchpad.net/~bsantos/+archive/ppa

Cson (theceason) wrote :

is also affect by click the icon on the dash app bar
11.10 all window
12.04 current window

Mark Mandel (mark-mandel) wrote :

Awesome - worked for me too on Xubuntu.

Thanks!!!

James Heany (digphan) wrote :

Can we expect this to be fixed through regular updates?

Another issue I have which I'm not sure is part of this bug or not. The expo feature and scale faeture of assigning a window corner (or top, bottom, sides) to activate window picker (scale) and worksapce picker (expo) stop working after a reboot. The window picker feature every single time, the workspace picker occasionally. The settingsa are not changed in compiz, but the only way to get them working again is to change the setting to off and then assign it back again. It will then work for as long as logged in. Is this attributed to this bug, or should a different bug report be filed?

works great but after restart :)
I have no ideea how the package system works. When the patch will be in the main PPA do I need to remove Bruno's PPA?

No, the new package will have a higher version than the one on the ppa
and will replace it automatically. :)

On Sáb 12 Mai 2012 13:08:16 WEST, Andrei Petcu wrote:
> works great but after restart :)
> I have no ideea how the package system works. When the patch will be in the main PPA do I need to remove Bruno's PPA?
>

Thanks a hundred times! It was so frustrating, especially using xfce where ordinary taskbar is unable to switch correctly between windows managed by compiz.

Andreas Zeller (luxmedien) wrote :

I also "fixed" it now by reverting to the old codebase.

Andrei: generally, you might want to keep that package from upgrading until somebody with a higher tolerance of pain lets you know when it is finally fixed. I'm guessing that the newer version will probably not actually have this fix included but have other stuff fixed. So if everything works for you, hold all the compiz upgrades for now.

This is of course not the way to beta-test, because you're waiting for a specific thing to be fixed for egoistic reasons (just like me :) ) - but for those of you just running into trouble and not interested in helping out with compiz, just stick with this "fix" and be happy for now :) to all the others: thanks for doing this...

kinda off-topic p.s.: I'm really considering going back to debian, since ubuntu is going down a certain path that I can no longer understand. I'm using neither gnome nor unity, I've been using lxde for a while now (not lubuntu though, used the lxde/compiz combo long before the flavor came out). BUT: the way I see it, gnome3 is pretty similar to unity, so why re-invent the wheel or try making stuff new that is already working?!

Compiz has been SUCH a relief to all window management fanatics and my personal productivity and efficiency has majorly improved ever since I've been using it. Started off with beryl btw. back in the kinda-old days... I don't get why development of ubuntu is so focused on unity. Nobody likes it and nobody wants to get used to something new. This human behavior has been around for ages and people have been using Window$ for the same stupid reason. Ubuntu has (had?) a great thing going, and now they're about to ruin everything by breaking stuff that is already working and trying to force people into their weird schemes instead of letting them just use whatever they want to use. It took another developer a very short time to fix this specific issue and there are lots of other compiz-related issues open that used to work before. There's this weird screen flicker on cube rotate (been around since 11.04), I can't ctrl-shift-arrow move windows any more (also since 11.04), and all this is just a sacrifice to unity, because nobody cares about cube rotate any more...

I don't want to use an operating system that tries to force my user-behavior into directions that I don't like.

sorry about that, but I'm at a point where those kinds of bugs are really starting to piss me off.

Cheers.

Andreas

matthieu vidal (mvidal0001) wrote :

Andreas calm down ... it's only a bug ... not an attempt to corrupt your soul.

"Unity" is important for Ubuntu because Ubuntu aims to create a linux distribution for humans ... not for geeks ... so they have to master their desktop entirely and not to deal with geeks fighting all over the world. Look how many desktops are useable on apple or windows or smartphone ...

Durand D'souza (durand1) wrote :

Andreas, I like Unity. I think it is slower that gnome 2 + compiz but change is good once in a while and there is no room for innovation unless we change things. I have also used compiz since the beryl/compiz split and I really love it. By the way, you can move windows between desktops with Ctrl-Alt-Shift-arrow. Works perfectly for me.

Andreas Zeller (luxmedien) wrote :

Matthieu: I know. It was not just this bug that set me off but the past two releases and all the regression we went through when it comes to compiz. I am not aiming at getting back an old hands-on linux where you have to do everything by hand. 10.04 was an amazing release, because there was almost NOTHING to do via terminal. With every further release of ubuntu (using unity), the more of this kind of functionality I lose. That's what I don't like.

Durand: I am not at all against change. Change is good, always has been. Sometimes you might like re-decorating your house, but you're not gonna rebuild your living-room and break the kitchen and the bathroom in the process, if you know what I mean :)

Try ctrl-alt-shift-arrow using the cube :) I know it works with the wall, that's exactly what I mean. Use anything but the stuff that is default in unity and it's gonna be low priority.

Sorry about causing this discussion. Didn't really wanna start an argument, just give those in charge of the component something to think about when they "enhance" something.

Danillo (danillo) wrote :

I also like Unity a lot. As a matter of fact, if it wasn't for Unity I would still be running 9.10 because not even the LTS was reason enough for me to upgrade before Unity. I think giving us an option to Gnome Shell and building it on top of Compiz was a wonderful decision.

These temporary problems are a necessary evil for us to move forward and spread free software everywhere. They will be fixed, we just need to be patient.

The cube problem is a duplicate of bug #862430 and it will be fixed soon.

Now let's stay on topic please.

Gaby (gaalonso) wrote :

Thanks bruno for PPA - works perfectly well .... will monitor this bug 'till fixed, but excelent w/a

Matthias Niess (mniess) wrote :

Everyone: This is a bug report and not a discussion forum. Take your discussion to forums, IRC or mailing lists. The comments here have one purpose only: adding information that gets the bug solved more quickly. N.B.: I'm still testing the patch for side effects.

Changed in compiz:
importance: Undecided → Medium
status: New → Triaged
James Heany (digphan) wrote :

Can anyone comment on my question as to whether the window edge actions being reset every reboot for the scale and expo actions are part of this bug or are another bug altogether?

Download full text (4.3 KiB)

Uhm for me, I need to kill compiz and then restart it again. After
that, the settings work as they should.

On 19 May 2012 16:46, James Heany <email address hidden> wrote:
> Can anyone comment on my question as to whether the window edge actions
> being reset every reboot for the scale and expo actions are part of this
> bug or are another bug altogether?
>
> --
> You received this bug notification because you are subscribed to a
> duplicate bug report (931601).
> https://bugs.launchpad.net/bugs/933776
>
> Title:
>  [regression] "Initiate Window Picker for All Windows" does not show
>  all windows. It shows only windows from curent workspace.
>
> Status in Compiz:
>  Triaged
> Status in Compiz Core:
>  Triaged
> Status in Unity:
>  Confirmed
> Status in “compiz” package in Ubuntu:
>  Triaged
> Status in “compiz” source package in Precise:
>  Triaged
>
> Bug description:
>  compiz expo plugin have the option to change the scale plugin behavior
>  but that does not work unity Unity..
>
>  1. start ccsm, go to scale plugin, go to bindings tab
>  2. see 'initiate window picker for all window' is enabled
>
>  What happen:
>  that setting is being overridden by Unity since super+w only shows windows from current workspace.
>
>  ProblemType: Bug
>  DistroRelease: Ubuntu 12.04
>  Package: compiz 1:0.9.7.0~bzr2995-0ubuntu2
>  ProcVersionSignature: Ubuntu 3.2.0-16.25-generic 3.2.6
>  Uname: Linux 3.2.0-16-generic x86_64
>  NonfreeKernelModules: fglrx
>  .tmp.unity.support.test.0:
>
>  ApportVersion: 1.91-0ubuntu1
>  Architecture: amd64
>  CompizPlugins: [core,bailer,detection,composite,opengl,decor,move,mousepoll,scale,compiztoolbox,imgpng,grid,obs,gnomecompat,place,workarounds,wall,resize,vpswitch,regex,snap,session,expo,ezoom,unityshell]
>  CompositorRunning: compiz
>  Date: Thu Feb 16 23:20:52 2012
>  DistUpgraded: Log time: 2012-02-11 11:37:02.610616
>  DistroCodename: precise
>  DistroVariant: ubuntu
>  DkmsStatus: fglrx-updates, 8.911, 3.2.0-16-generic, x86_64: installed
>  GraphicsCard:
>   Advanced Micro Devices [AMD] nee ATI Madison [Mobility Radeon HD 5000 Series] [1002:68c0] (prog-if 00 [VGA controller])
>     Subsystem: ASUSTeK Computer Inc. Device [1043:1c22]
>  InstallationMedia: Ubuntu 12.04 LTS "Precise Pangolin" - Alpha amd64 (20120210)
>  JockeyStatus:
>   xorg:fglrx_updates - ATI/AMD proprietary FGLRX graphics driver (post-release updates) (Proprietary, Disabled, Not in use)
>   xorg:fglrx - ATI/AMD proprietary FGLRX graphics driver (Proprietary, Disabled, Not in use)
>  MachineType: ASUSTeK Computer Inc. N61Ja
>  PackageArchitecture: all
>  ProcKernelCmdLine: BOOT_IMAGE=/boot/vmlinuz-3.2.0-16-generic root=UUID=e92c1dca-3eb6-43ed-b0ac-faeaabed4bc9 ro quiet splash vt.handoff=7
>  SourcePackage: compiz
>  UpgradeStatus: Upgraded to precise on 2012-02-11 (5 days ago)
>  dmi.bios.date: 05/19/2010
>  dmi.bios.vendor: American Megatrends Inc.
>  dmi.bios.version: N61Ja.211
>  dmi.board.asset.tag: ATN12345678901234567
>  dmi.board.name: N61Ja
>  dmi.board.vendor: ASUSTeK Computer Inc.
>  dmi.board.version: 1.0
>  dmi.chassis.asset.tag: ATN12345678901234567
>  dmi.chassis.type: 10
>  dmi.chassis.vendor: ASUSTeK Computer Inc.
>  dmi.chassis.vers...

Read more...

I think it is a different bug in which your configuration is not saved.
This bug is specific "Initiate Window Picker for All Windows" does not show
all windows. It shows only windows from curent workspace.

Changed in compiz:
milestone: none → 0.9.8.0
Changed in compiz-core:
milestone: 0.9.8.0 → 0.9.7.10
Charles Opondo (charlesopondo) wrote :

Thanks Bruno for an excellent solution, worked like magic on my system.

Thank you Bruno so much!

junomedia (junomedia) wrote :

Thank you Bruno!

Smeagol (gollum12345678) wrote :

Thank you Bruno! =)

Vodka (vodkaneat) wrote :

Thank you Bruno/Doug!

Matthias Niess (mniess) wrote :

With all the "thank you" posts, I'd say the fix is well tested. Can we have it now? Sam Spilsbury?

Daniel van Vugt (vanvugt) wrote :

The fix will be reviewed before the next SRU. However it may take a different form, because there are other scale plugin regressions introduced in 12.04 that we'd also like to fix. And they all seem to be caused by a single commit. So it's possible the first thing we do is revert that one commit that is causing all the regressions.

It makes little sense to try and fix each regression independently when we could just take one step back to eliminate all the scale/spread regressions (including this one I assume), and re-implement the offending change more safely. There's less code change required, less review required, more bugs fixed with less effort, and that gives everyone a higher degree of confidence.

Changed in compiz (Ubuntu Precise):
milestone: none → ubuntu-12.04.1
Changed in compiz (Ubuntu):
importance: Medium → High
Changed in compiz (Ubuntu Precise):
importance: Medium → High
Matthias Niess (mniess) wrote :

Okay. Thanks for the feedback! I noticed some other problems so I'm all for moving a step back ;)

Youbantu (youbantu) wrote :

So this fix (https://launchpad.net/~bsantos/+archive/ppa) also helps me.
Thank you Bruno/Dough.

Changed in compiz-core:
assignee: nobody → Łukasz Zemczak (sil2100)
Changed in compiz:
assignee: nobody → Łukasz Zemczak (sil2100)
summary: - [regression] "Initiate Window Picker for All Windows" does not show all
- windows. It shows only windows from curent workspace.
+ [regression] scale/spread: "Initiate Window Picker for All Windows" does
+ not show all windows. It shows only windows from curent workspace.
Changed in compiz-core:
status: Triaged → In Progress
Changed in compiz:
status: Triaged → In Progress
no longer affects: unity
description: updated
Łukasz Zemczak (sil2100) wrote :

Thanks for testing. And thanks for the window picker fix Doug!
Sadly, even though we wanted to include this fix in this SRU, it seems we won't make it in time, as the fix requires unit-tests, which in compiz require a bit more time to write and prepare. But I'll include it in the next SRU ASAP, since I know how annoying this bug is for everyone.

Changed in compiz-core:
milestone: 0.9.7.10 → 0.9.7.12
Bonzo (bonzo-bvd) wrote :

Ubuntu have released a Compiz "update" yesterday and the fixed Scale plugin from Bruno's PPA have been overwritten, reverting to the buggy Scale plugin. And I cannot revert changes without breaking Unity!!

Months without fixing this bug and doing updates ruining Bruno's fix. What are Ubuntu developers doing?! This is very frustrating. I will migrate to Linux Mint very soon...

I will update my pkgs with the new release. Started it this afternoon but
didnt have time to finish it. I hope the next update has this fixed...
Sorry for the delay.

On Friday, June 29, 2012, Bonzo <email address hidden> wrote:
> Ubuntu have released a Compiz "update" yesterday and the fixed Scale
> plugin from Bruno's PPA have been overwritten, reverting to the buggy
> Scale plugin. And I cannot revert changes without breaking Unity!!
>
> Months without fixing this bug and doing updates ruining Bruno's fix.
> What are Ubuntu developers doing?! This is very frustrating. I will
> migrate to Linux Mint very soon...
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/933776
>
> Title:
> [regression] scale/spread: "Initiate Window Picker for All Windows"
> does not show all windows. It shows only windows from curent
> workspace.
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/compiz/+bug/933776/+subscriptions
>

Francivan Bezerra (fba-ig) wrote :
Download full text (5.8 KiB)

Why developers of Ubuntu don't fix this issue once and for all??

2012/6/29 Bruno Santos <email address hidden>

> I will update my pkgs with the new release. Started it this afternoon but
> didnt have time to finish it. I hope the next update has this fixed...
> Sorry for the delay.
>
> On Friday, June 29, 2012, Bonzo <email address hidden> wrote:
> > Ubuntu have released a Compiz "update" yesterday and the fixed Scale
> > plugin from Bruno's PPA have been overwritten, reverting to the buggy
> > Scale plugin. And I cannot revert changes without breaking Unity!!
> >
> > Months without fixing this bug and doing updates ruining Bruno's fix.
> > What are Ubuntu developers doing?! This is very frustrating. I will
> > migrate to Linux Mint very soon...
> >
> > --
> > You received this bug notification because you are subscribed to the bug
> > report.
> > https://bugs.launchpad.net/bugs/933776
> >
> > Title:
> > [regression] scale/spread: "Initiate Window Picker for All Windows"
> > does not show all windows. It shows only windows from curent
> > workspace.
> >
> > To manage notifications about this bug go to:
> > https://bugs.launchpad.net/compiz/+bug/933776/+subscriptions
> >
>
> --
> You received this bug notification because you are subscribed to a
> duplicate bug report (991133).
> https://bugs.launchpad.net/bugs/933776
>
> Title:
> [regression] scale/spread: "Initiate Window Picker for All Windows"
> does not show all windows. It shows only windows from curent
> workspace.
>
> Status in Compiz:
> In Progress
> Status in Compiz Core:
> In Progress
> Status in “compiz” package in Ubuntu:
> Triaged
> Status in “compiz” source package in Precise:
> Triaged
>
> Bug description:
> [Test Case]
> 1. Open few applications on workspace 1
> 2. Open a few more applications on workspace 2
> 3. Press the shortcut for 'initiate window picker for all windows'
> (Super+W by default)
> -> Verify that the scale plugin shows windows from both workspaces,
> not only from one of them
>
> 4. To verify, press the shortcut for 'initiate window picker'
> (Shift+Alt+UpArrow by default)
> -> Verify that the scale plugin only shows windows from the current
> workspace
>
> [Regression Potential]
> No real regression potential, in the impossible case the scale plugin
> might stop working
>
> Original description:
>
> compiz expo plugin have the option to change the scale plugin behavior
> but that does not work unity Unity..
>
> 1. start ccsm, go to scale plugin, go to bindings tab
> 2. see 'initiate window picker for all window' is enabled
>
> What happen:
> that setting is being overridden by Unity since super+w only shows
> windows from current workspace.
>
> ProblemType: Bug
> DistroRelease: Ubuntu 12.04
> Package: compiz 1:0.9.7.0~bzr2995-0ubuntu2
> ProcVersionSignature: Ubuntu 3.2.0-16.25-generic 3.2.6
> Uname: Linux 3.2.0-16-generic x86_64
> NonfreeKernelModules: fglrx
> .tmp.unity.support.test.0:
>
> ApportVersion: 1.91-0ubuntu1
> Architecture: amd64
> CompizPlugins:
> [core,bailer,detection,composite,opengl,decor,move,mousepoll,scale,compiztoolbox,imgpng,grid,obs,gnomecompat,place,workarounds,wall,resize,vpswitch,regex,snap,ses...

Read more...

I have just updated from the PPA. Now scale works again as expected. I hope Ubuntu devselopers won't give us another broken update in a while...

Thanks, Bruno.

On 06/30/2012 10:59 AM, Bonzo wrote:
> I have just updated from the PPA. Now scale works again as expected. I
> hope Ubuntu devselopers won't give us another broken update in a
> while...
>
> Thanks, Bruno.
>
You really can't 'break' something that's not been fixed yet.
If you choose to use a modified source, either your own doing or thru a
ppa then you need to bear a little responsibility when an update appears
for that source, no one is forcing you to update uninformed.
That's why there are changelogs, when this bug is officially 'fix
released' it will be noted in a compiz* update

Changed in compiz-core:
milestone: 0.9.7.12 → 0.9.7.10
tags: added: scale

Fix committed into lp:compiz at revision 3271

Changed in compiz:
status: In Progress → Fix Committed
Changed in compiz-core:
status: In Progress → Fix Committed
Daniel van Vugt (vanvugt) wrote :

Fix committed into lp:compiz-core/0.9.7 at revision 3110

Łukasz Zemczak (sil2100) wrote :

I ask of just a bit of patience here. As I already said, the patch/fix is ready, but sadly didn't make it to the last SRU due to time deadlines - due to the new more rigorous rules. But I assure you that this fix will be present in the next update and the problem will be essentially fixed once and for all.

Timo Jyrinki (timo-jyrinki) wrote :

12.04 LTS packages for testing at https://launchpad.net/~timo-jyrinki/+archive/compiz-precise-sru - please give feedback

Woohoo! This is fixed in that PPA from Timo.

Miklos Juhasz (mjuhasz) wrote :

Using Timo's ppa Super+W for spreading all windows works fine here.

Miklos Juhasz (mjuhasz) wrote :

One thing I forgot to double check: Super+W is for spreading all windows in _all_ workspaces but the Unity shortcut hints overlay shows "Spreading all windows in the _current_ workspace" which is Shift+Alt+Up actually.

Timo Jyrinki (timo-jyrinki) wrote :

Apparently the fix unfortunately still would revert the fix for bug #689733, so it, as a default behavior change, cannot be included without design approval :( It could be offered as an optional change in behavior later on, but not changing the default behavior.

Daniel van Vugt (vanvugt) wrote :

Miklos,

Yes an additional fix is required downstream in Ubuntu as I mentioned in comment #47:

`This bug will require a fix upstream and downstream...

Upstream: Make sure all windows are shown for the "all windows" bindings.
Downstream: Move the Super+W shortcut from "Initiate Window Picker For All Windows" into "Initiate Window Picker"'

Daniel van Vugt (vanvugt) wrote :

Timo, this fix is correct. Ubuntu's Unity/Compiz is just bound to the wrong action, as per my previous comments.

Miklos Juhasz (mjuhasz) wrote :

Thanks, Daniel! I must have missed that comment.

The early 12.04 releases (alfa, beta, I don't remember) had the correct text ("all windows, all workspaces"). A bug on this issue was reported and the fix was correcting the documentation and the shortcuts overlay. This was not a proper fix. This is a design regression bug, it's not a design change.

Daniel van Vugt (vanvugt) wrote :

Timo, Super+W is bound to the wrong action in:
debian/patches/ubuntu-config.patch

Sebastien Bacher (seb128) wrote :

changing the ubuntu config is tricky though since we have no good solution to migrate existant configs, so changing the code would lead to behaviour changes for those existing profiles ... it might be easier to add a new function in compiz to do the same thing rather than change the existing one, it's a bit of an hack but it would allow users to opt in for the new one without breaking upgrades

Bruno Santos (bsantos) wrote :

Using the current behavior leads to windows flying all over the place, invisible windows, windows stuck outside of the viewport, etc. I can't see how anyone can use this in its' current state.

Things were changed for this new behavior, braking the previous behavior for everyone who used it (it is impossible to show all the windows from all the desktops). I can't understand how hacking this instead of fixing the expected behavior is better.

I remember compiz 0.8 was great to use, fast, I don't remember all this windows drawing artifacts and lag. Maybe I have a bad memory, and the rewrite was for the better. I have been always against the "I'm moving to distro X" naysayers, but I'm reaching my limit, and am tired of being unable to work because of critical regressions that change the behavior of the desktop all the time, and linger to be fixed, which is even worse when there are public patches that lots of people have been using for ages without known issues.

I fear for the transition to Wayland... :-(

I know, I know, this isn't a forum, and this doesn't help, and whatever, but I've been happily using Ubuntu for so long, that coming to this is making me very frustrated and sad, and I believe the more than 200 people reporting having this bug for so long are too.

Sebastien Bacher (seb128) wrote :

@Bruno: please don't confuse things and don't use that bug to complain about every other issue you might get with compiz

> Using the current behavior leads to windows flying all over the place, invisible windows, windows stuck outside of the viewport, etc. I can't see how anyone can use this in its' current state.

I'm using the current version, I've nothing "flying all over the place", no invisible windows, no windows stuck outside of viewports ... those are all different issues, open new bugs about those they have nothing with the ticket open there

> Things were changed for this new behavior, braking the previous behavior for everyone who used it (it is impossible to show all the windows from all the desktops). I can't understand how hacking this instead of fixing the expected behavior is better.

Not sure what you are talking about but fixing the "one workspace or all workspace" action will fix none of the issues you complain about

> which is even worse when there are public patches that lots of people have been using for ages without known issues.

where? you mean the patch there which changes the desktop behaviour? the things you just complained about, being tired of "that change the behavior of the desktop all the time" ... now you complain that we want to keep some stability? if you want some credibility there you get to pick, do you want things changing all the time and again to fix that issue or do you want things to keep working in a consistant way?

> I fear for the transition to Wayland... :-(

what has wayland to do with any of this?

> I know, I know, this isn't a forum, and this doesn't help, and whatever, but I've been happily using Ubuntu for so long, that coming to this is making me very frustrated and sad, and I believe the more than 200 people reporting having this bug for so long are too.

sorry about that, but you are using work from volunteers there, you are paying nothing for the product and people do the best to help, it's a bit easy and unfair to just blame people who work for you on free to not work enough

Bruno Santos (bsantos) wrote :

I replied to Sebastien privately, I don't want to add more noise to this bug report.

Please, keep up the good work. ;-)

Bonzo (bonzo-bvd) wrote :

Today Ubuntu has pulled new updates on Compiz. I haven't found any mention to this bug on the changelogs. Can someone confirm tha the bug is still there (or not) in the new updates? I think I'll stick to Bruno's version for a while.

Thanks.

PD: About the discussion in this this thread, I think we do not complain about Ubuntu devs effort. We appreciate it, of course. We complain about the priority of this bug (many months old, at least three compiz updates without fixing it). We think it should be high priority as it affects our workflow using our sistems on a daily basis. Ubuntu crew do not. It's not personal, it is just thinks are.

On 12-07-2012 15:43, Bonzo wrote:
> Today Ubuntu has pulled new updates on Compiz. I haven't found any
> mention to this bug on the changelogs. Can someone confirm tha the bug
> is still there (or not) in the new updates? I think I'll stick to
> Bruno's version for a while.

I think the previous version (in proposed) had this patches:

  [ Łukasz 'sil2100' Zemczak ]
   * Cherry-pick upstream patches:
     - CMake Error at FindCompiz.cmake:84 (include): include could not
find load
       file: CompizDefaults (LP: #993608)
     - compiz (decor) - Warn: failed to bind pixmap to texture (LP: #929989)
     - gtk-window-decorator crashed with SIGFPE in
       _decor_blend_horz_border_picture() (LP: #963794)
     - [callgrind] compiz spends ~25% of its time constructing/destructing
       strings in PrivateScreen::handleActionEvent (LP: #1005569)
     - gtk-window-decorator crashed with SIGSEGV in
meta_get_decoration_geometry
       (LP: #1007754)
     - composite refresh rate falls back to 50Hz, which is wrong in most
cases
       (LP: #1009338)
     - [callgrind] compiz spends ~7% of its time inserting into and
destructing
       the events list in PrivateScreen::processEvents() (LP: #1006335)

Then they were reverted in the current version. The patch to this bug
wasn't included in both. Maybe Łukasz can tell us, if it is decided that
this patch is viable, if it will be included in the re-release of the
SRU patches, or a future SRU.

There is another ppa with the same patch I used on mine that also
includes a few other patches that may be useful for some of you:
https://launchpad.net/~mjuhasz/+archive/backports

Miklos has already built against the current compiz package in proposed,
and added some patches to unity work with the differences in the
behavior, as discussed here.

Well, the priority are sorted by what affects most users, we had quite some bugs which made compiz,unity impossible to use at all or really slow to use on some hardware (still have some) and that got the priority over "the spread is working by workspace" which is an usability issue but trivial to work around and not breaking anything out of habits... we will get to those though, almost there, please be patient

John Lea (johnlea) on 2012-07-12
description: updated
Matthias Niess (mniess) wrote :

@Sebastien, regarding your lengthy comment at Bruno: I don't want to add more noise but remind you of an older comment. In comment #88 Daniel stated that this regression is caused by a single commit that caused multiple regressions in scale. I have the same issues as Bruno on every single (vanilla) Ubuntu machine I supervise. Super+w sometimes does send windows fly all over the place and I do get empty windows a lot.

If this is all caused by one commit, aren't all these regressions essentially the same bug?

Doug McMahon (mc3man) wrote :

Just a small comment to possibly clear up a previous one

There is a possibility that the very first time scale > all windows from all ws's is used that instead of going to the scale, windows will instead try to leave or come into the screen, the "windows flying all over.."

This doesn't happen all the time & only occurs the *first time used*, then doesn't return, at least as seen here over the course of maybe 50 installs & scale fixed since last mid-winter.

I have never seen invisible windows in the scale spread based on this fix, there may have been times during 12.04 dev that that happened though I don't believe solely because of fixing scale for this issue.

Matthias Niess (mniess) wrote :

Regarding a mechanism to properly migrate users-settings without hacking new stuff into compiz:
There are several packages that trigger a notification that asks the user to do stuff. ecryptfs asks the users to write down their passphrases, dropbox asks them to restart nautilus.

What about adding that kind of notification just to this particular update telling the user that some compiz settings have to be reset to their default value. There could be a button that runs a script which does a recursive-unset on the relevant keys. I'm pretty sure these notifications work on a per-user basis, so that multiple users on a system will all get the message to run the script.

Sebastien Bacher (seb128) wrote :

@Matthias: no, we can fix the issues you mention without making the scale not being by workspace, bug #955035 seems like the issue you describe?

> There are several packages that trigger a notification that asks the user to do stuff.

right, we hate those, users see it as an annoyance, most don't read it or understand what is written and just click and get their config changed and then complain, we try to avoid those if we can

Matthias Niess (mniess) wrote :

The updated packages in in Timos PPA (0.9.7.8-0ubuntu1.3~test5) don't fix the bug for me. Neither this bug, nor #955035 are fixed for me. Super+w only shows current workspace windows and looking in ccms it is bound to "show windows from all workspaces".

Miklos Juhasz (mjuhasz) wrote :

@Mathis: the latest (~test5) packages in Timo's ppa do not have the patch for this bug and #955035 anymore. I guess Timo is preparing the SRU and the fix for this bug will probably not make it because it needs more work (see description of this bug - John Lea added a desired resolution section).

Changed in compiz (Ubuntu Precise):
milestone: ubuntu-12.04.1 → ubuntu-12.04.2
Youbantu (youbantu) wrote :

Dear all.

I still use the ppa from Bruno (thanks again Bruno!) and all is fine. I'm just wondering if it is also in the official ubuntu ppa. Is it? Shall I still wait and until when? Thx for some comments, cheers.

PS: Sorry, the conversations are quite long to read and not easy to understand at once (I'm not really an expert)

Launchpad Janitor (janitor) wrote :
Download full text (7.9 KiB)

This bug was fixed in the package compiz - 1:0.9.8+bzr3319-0ubuntu1

---------------
compiz (1:0.9.8+bzr3319-0ubuntu1) quantal-proposed; urgency=low

  [ Didier Roche ]
  * debian/patches/ubuntu-config.patch:
    - refresh with latest trunk
  * debian/*docs:
    - remove the TODO copy now removed upstream
  * debian/compiz-plugins.install:
    - install stackswitch, trip plugins
  * debian/rules, debian/control:
    - remove the compiz gnome-control-center key sedding through metacity.
      Compiz now directly ships them.
    - we do not need metacity-common anymore as a build-dep then
  * debian/compiz-gnome.migrations, debian/control:
    - build-dep on dh-migrations and ship gconf -> gsettings migration file

  [ Matthieu Baerts (matttbe) ]
  * Update apport hook for python3 ; thanks to Edward Donovan (LP: #1013171)

  [ Timo Jyrinki ]
  * New upstream snapshot.
    - Fix Compiz crash in movementWindowOnScreen (LP: #1015151)
    - Start window decorator when decor plugin starts (LP: #1014461)
    - Fixed: Crash in compiz::wall::movementWindowOnScreen (LP: #1015151)
    - Don't waste memory leaving /bin/sh running (LP: #1015422)
    - Add reliable detection of the compiz bin directory (LP: #1015898)
    - Check if the window would actually paint before painting the shadow,
      since it is possible that another plugin could be inhibiting paint of
      the dock window. (LP: #1012956)
    - Don't insert the window into the server list above the window it was
      created above. (LP: #1008020) (LP: #886605)
    - makes compiz enhanced zoom and show mouse plugins considerably
      smoother to use (LP: #930783)
    - Don't set decoration contexts on undecorated windows, since that
      might be read later and code will assume the window is decorated when
      it isn't. (LP: #1015593)
    - Fix potentially unterminated string leading to an uninitialized memory
      read (LP: #1018302)
    - Lift the 31/32 character restriction on key names that was causing so
      many warnings. It's now 1024 characters according to glib. (LP: #1018730)
    - Don't print the result of BUILD_DEB. It prevents ccsm et al from
      installing. (LP: #1018916)
    - Use the XDamage extension more efficiently (the way it was designed to be
      used). This dramatically reduces CPU usage, reduces wakeups, and
      increases frame rates. It also solves at least one observed performance
      bug (LP: #1007299) and probably several more.
    - Do the initial work to get libcompizconfig under test. (LP: #990690)
    - Add support for initiating window picker in other than nomal mode. For
      now added only the additional 'All windows' picker (LP: #933776)
      (LP: #955035)
    - Fixes (LP: #1018602) : An invalid read when using g_variant_iter_loop.
    - Don't allow unbinds of textures kept around for animations in any case,
      not just resizing. (LP: #1016366)
    - Wait for the server to finish processing requests before doing a bind
      (LP: #1016367)
    - Using the next/previous bindings the wall plugin didn't calculate
      correctly the next workspace when it reaches the begin or the end of a
      row of workspaces, so it didn't jump to the n...

Read more...

Changed in compiz (Ubuntu):
status: Triaged → Fix Released
Matthias Niess (mniess) wrote :

Looks like this is fixed for quantal. Will the fix be backported to precise?

Daniel van Vugt (vanvugt) wrote :

Yes, the backport to precise (compiz 0.9.7) is under way. See the milestones at the top.

Changed in compiz:
status: Fix Committed → Fix Released
zouhair (zouhair-mahboubi) wrote :

Any update on when the backport to precise (12.04 LTS) will be completed?

Thanks

VladimirCZ (vlabla) wrote :

 update on when the backport to precise (12.04 LTS) will be completed?

Thanks

Paulus (donmatteo) wrote :

This bug has been marked "fix released" for almost two months now, but the precise-backports doesn't include a fixed package yet. Any chance we could get a package for testing at least?

James Heany (digphan) wrote :

This bug finally seems to be fixed with the new 12.10 release. But many will stick with 12.04 since it is a LTS version. Are there plans to fix this in 12.04?

Daniel van Vugt (vanvugt) wrote :

Yes, the fix is scheduled for release in precise compiz 0.9.7.10. I'm not yet sure when that will be released though.

Changed in compiz-core:
status: Fix Committed → Triaged
Changed in compiz (Ubuntu Precise):
status: Triaged → Confirmed
Timo Jyrinki (timo-jyrinki) wrote :

Putting back to Confirmed for 12.04, since the commit in question was eventually reverted and the problem is more complex in 12.04 than it would first seem. The bug itself would be fixable, as known, but not without changing the default behavior for all users which is not wanted.

The desired 12.04 solution of having the default unchanged but adding two new shortcut keys to GNOME Control Center as described in the bug description would be otherwise acceptable, but it's tricky and there is no such work done. The problem as I understand it is that the current default key combo in 12.04 (but not in 12.10) is bound to the wrong action, so there would be a upgrade migration mechanism required and it still might have hard time getting accepted into a stable upgrade in fear of regressions.

Meanwhile, as this is now not included even in the next precise SRU, I created a PPA including the next proposed compiz SRU added with this fix - ppa:timo-jyrinki/compiz-12.04-fix-933776

Matthias Niess (mniess) wrote :

As it currently stands, I'd like to remind you of what I wrote in #122. Compiz in 12.04 is broken. I get calls on an almost daily basis because this bug breaks window management. If all that holds us back from reverting that one commit are changed shortcuts then lets make an exception.

Sebastien wrote in #123 that you hate those dpkg notifications that prompt the user to do some actions. But looking at the 3 options we have, I know which one I'd pick:

1. live with a broken compiz
2. hack compiz to add an extra "show all windows" option, additionally to the existing one, that actually does show all windows so that we don't have to change shortcuts (this would be an awefully ugly hack IMO)
3. display a notification on upgrade "Due to an upgrade some of your shortcuts for window management need to be restored. Please click on 'Restore shortcuts' to do that now." (which runs a script to recursively unset the relevant keys, or - if you want to get fancy - checks the currently defined shortcuts and sets them at the appropriate places).

I really really think we should go with option 3. Do we really want two "initiate window picker on all viewports" options?

Changed in compiz-core:
milestone: 0.9.7.10 → 0.9.7.12
drplix (pjr-1060) wrote :

This bug is really bad and ruins the LTS experience. I've been running with Bruno's PPA for 6 months - which fixes the problem perfectly - but I can't imagine what its been like for anyone not technically savvy enough to use this.

This week I got an official update to compiz which I naively assumed would mean that this was finally officially fixed. I was badly wrong - its now back to being totally broken. Worse still, the installed version supercedes Brunos version number and so I can't go back to his fix (my system is critical to me so I don't want to muck about with pinning older versions).

Please someone release the fixed version to the LTS backports - this is getting beyond the limits of reasonable patience.

Hi guys, I've been using Quantal, so I can't test if the patch still works.

On the new package version that was released there's a patch reverting
the fix for this bug. I've applied the fix after that patch, let's see
if it builds, and if so you should receive an update on my ppa.

On Sat, Dec 8, 2012 at 11:26 AM, drplix <email address hidden> wrote:
> This bug is really bad and ruins the LTS experience. I've been running
> with Bruno's PPA for 6 months - which fixes the problem perfectly - but
> I can't imagine what its been like for anyone not technically savvy
> enough to use this.
>
> This week I got an official update to compiz which I naively assumed
> would mean that this was finally officially fixed. I was badly wrong -
> its now back to being totally broken. Worse still, the installed
> version supercedes Brunos version number and so I can't go back to his
> fix (my system is critical to me so I don't want to muck about with
> pinning older versions).
>
> Please someone release the fixed version to the LTS backports - this is
> getting beyond the limits of reasonable patience.
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/933776
>
> Title:
> [regression] scale/spread: "Initiate Window Picker for All Windows"
> does not show all windows. It shows only windows from curent
> workspace.
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/ayatana-design/+bug/933776/+subscriptions

Hi Bruno - thank you! I just got the update from your PPA and can confirm that we're back in business! The bug is fixed again with your version.

You are a gentleman. Thank you.

zzecool (zzecool) wrote :

Me and my friend was the first to add this bug here and i cant believe that this one still exist in precise.....

Im using quantal long time now so im not having this bug any more but it is a shame that this is not fixed on LTS and it is fixed in Quantal ..

It is many times that i have the feeling that devs don't give a shit about what us normal user asking here.

235 people and almost a year later should have already made some attention to the Dev team .

I think we are getting confused between LTS and "i don't give a damn, as long as it isn't security patch we don't update it".

Łukasz Zemczak (sil2100) wrote :

Ok, I think this needs some clarification. The bug is not fixed because no dev had time to do it. It was actually fixed quite a long time ago, but the fix got reverted. Sadly, bugs like these are really hard to 'fix', because those do not really fit the SRU criteria. Stable releases can only have SRUable bugs fixed.

To fix this bug, it would mean to change the current *default behavior*. Fixes like these are unacceptable after Feature Freeze, so pushing a modification like this to Quantal and Precise is something that would have to be forced with the design teams and the release teams.

I created a fix (basing my work on what Bruno did), I pushed it to compiz, but the design team rejected the change, as it is too late to change the default behavior of keybindings. It's a complicated issue. I would rather have it fixed as well, but hm, that's not so easy to do 'paper-work' wise...

What I think confuses us is the fact that this default behavior is a
regression on the behavior of the previous version, or else there wouldn't
be all these reports and Quantal would show the same wrong behavior.

I have just been packaging a patch someone was kind to write and provide,
as long as it works with the updated packages I'll continue to publish it.
This won't be fixed as have been said by various people, maybe we should
just let it go...

Cheers,
Bruno
No dia 8 de Dez de 2012 23:50, "Łukasz Zemczak" <email address hidden>
escreveu:

> Ok, I think this needs some clarification. The bug is not fixed because
> no dev had time to do it. It was actually fixed quite a long time ago,
> but the fix got reverted. Sadly, bugs like these are really hard to
> 'fix', because those do not really fit the SRU criteria. Stable releases
> can only have SRUable bugs fixed.
>
> To fix this bug, it would mean to change the current *default behavior*.
> Fixes like these are unacceptable after Feature Freeze, so pushing a
> modification like this to Quantal and Precise is something that would
> have to be forced with the design teams and the release teams.
>
> I created a fix (basing my work on what Bruno did), I pushed it to
> compiz, but the design team rejected the change, as it is too late to
> change the default behavior of keybindings. It's a complicated issue. I
> would rather have it fixed as well, but hm, that's not so easy to do
> 'paper-work' wise...
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/933776
>
> Title:
> [regression] scale/spread: "Initiate Window Picker for All Windows"
> does not show all windows. It shows only windows from curent
> workspace.
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/ayatana-design/+bug/933776/+subscriptions
>

I'm failing to see how is fixing this equvivalent to changing default behaviour. The problem is, as I understand, that in one moment Scale plugin's actions "Initiate window picker for all windows" and "Initiate window picker (for current workspace)" became the same - "Initiate window picker (for current workspace)". They both behave exactly the same way.

Instead to bind the shortcut to later action, they CHANGED the former to behave exactly like the later. The result - an important functionality is thrown out because it was easier to make "Initiate window picker for all windows" behave exactly like "Initiate window picker (for current workspace)" , than to just bind the shortcut to "Initiate window picker (for current workspace)" and to leave "Initiate window picker for all windows" to be used if someone desires. I do not know any other way in Unity to drag and drop files between windows on different workspaces.

One word "unbelievable".

I almost stopped using multiple workspaces in ubuntu due this bug (thanks for bug-fix Bruno). It was really uncomfortable switching windows without picker from all windows.

Francivan Bezerra (fba-ig) wrote :

“To fix this bug, it would mean to change the current *default behavior*.”

OK, so let me see if I got this straight: you mean that on the designers point of view the *default behavior* is the *broken behavior*?

One word: “unbelievable”.

Daniel van Vugt (vanvugt) wrote :

Without reading the details of this bug again or forcing an opinion, everyone please note:

This bug is marked as fix released in Compiz 0.9.8.0. That means the fix is in Ubuntu 12.10 and later, but not in 12.04.

If you have a problem with the behaviour in 12.10 or later, please log a bug using this command:
    ubuntu-bug compiz

If you are using 12.04 or earlier, then this is the right place to keep discussing. As far as I can tell, it's just a matter of Ubuntu distro policy that "default behaviour" cannot be changed after release. Even if it is "broken behaviour", which we certainly agree. Remember you're complaining to developers who want the bug fixed in 12.04 too. But it's not always our call.

Matthias Niess (mniess) wrote :

I don't see how a corporate environment profits from installing non-LTS releases or using an obscure PPA (no offense Bruno) to get rid of this bug. This bug (and the many bugs resulting from the commit that causes it) makes 12.04 kind of unusable for many people. All options are on the table. Living with a broken Ubuntu for the next two years can't be the preferred option.

Doug McMahon (mc3man) wrote :

"Desired resolution:

- As the change request conflicts with bug #689733 , the current default behaviour of the spread should not change. Also significant changes to Ubuntu's default behaviour should not be made in a SRU."

Why this is in the current description makes no sense, that unfortunate bug targeted the left click on launcher icon & by extension - 'window picker for for window *group*', nothing really to do with this.

As far as 12.04 - the fix's 'change in behavior' seems to be just surrounding a default keybinding - super+w, not really qualifying as " significant "

Eddie Dunn (eddie-dunn) wrote :

If policy prevents fixing broken behavior it seems to me said policy needs to be amended.

The bug 689733 has now a "heat" of 184 while this has "1090". So which behavior is more critical from a user point of view?

John Lea (johnlea) wrote :

@desgua; that's because it is the current implementation, and people generally don't comment if they are happy with the status quo.

We had *a lot* of requests from the community to make the change described in bug #689733, so this debate is really is 6 of one, half a dozen of another.

If we were to change the behaviour around to what it was before bug #689733 was implemented I guarantee we will have an equal number of people complaining that "I use workspaces to segment tasks/areas of life/contexts, for example I have one workspace for personal stuff I use in my lunch break, another workspace I use for work, and another workspace dedicated to the report I am working on. I use workspaces so that I can focus on the task at hand, please don't always display windows from other workspaces that I am not currently using."

The issue is that there are several valid different ways of using workspaces, and we don't want to make a change that will inconvenience all the users who requested that we make the change described in bug #689733 in the first place.

This is why this bug requests that this behaviour is made configurable in System Settings:

------------------------------

"- In the short term what we can do is expose this option in 'System Settings / Keyboard / Shortcuts'. We can add two new actions to this panel:

'Spread all windows on the current workspace' (default setting: Super+W)
and
'Spread all windows on all workspaces' (default setting: Disabled)

and then it will be easy for users to choose the behaviour that suites them best."

------------------------------

Can you see any alternative means of making all classes of workspace users happy without introducing this configuration option?

@John Lea, I think that exposing this option in 'System Settings / Keyboard
/ Shortcuts' is a great solution that could be landed in 12.04. Don't you
agree?

@johnlea: I proposed a solution in #122 and #136.

If I understand correctly bug #689733 was just an incorrectly set shortcut (super+w was set to "scale all viewports" instead of "scale current viewport"). The solution (again, if I understand correctly) was to hack "scale all viewports" to display only the windows on the current viewport (which is an ugly hack and introduced a ton of other bugs).

Introducing a new option to compiz and keeping "scale all viewports" as it is would cause problems with with the upgrade path to 14.04, wouldn't it?

Having to change a keycombo is such a minor annoyance compared to having this bug (and all that come with it, flying windows, etc.). And as proposed in #122 we could even do it automatically.

christian (chmathieu) wrote :

Sorry, but for me, this is definitely a bug exists only in 12.04:

with ccsm (Window Management / Scale / Assignments)
it is possible to set 'Start selector windows for all windows':
  -> It works until 10.04
with 12.04 it does not work ==> BUG! ! !
-> From 13.04, it works again

----- google translate from french -----

Désolé, mais pour moi, cela reste définitivement un bug existant uniquement dans 12.04:

avec ccsm (Gestion des fenêtres/Echelle/Assignations),
il est possible de paramétrer 'Lancer le sélecteur de fenêtres pour toutes les fenêtres' :
 --> jusque 10.04 cela fonctionne
avec 12.04 cela ne fonctionne pas ==> BUG ! ! !
--> depuis 13.04, cela refonctionne

zzecool (zzecool) wrote :

We have a very nice expression here in Greece ..

"Πνίγεσαι σε μια κουταλιά νερό"

in free translation

"drowning in a teaspoon of water"

And this is what is really happening with this bug. The whole situation is a joke.

This is a bug and a regression , if it is to hunt and file a report about a so serious bug at 16/2/2012 during the Precise "Alpha 2" !!!!!
to find out that the bug is still here with so much attention , not even after beta1 beta2 but 8 months after the Final LTS release ... then i don't really know why i have to file a bug report again than pray and hope for a fix ...

^^ zzecool hit the nail on the head. They had the chance to fix this before whatever deadline that made impossible to change default behaviour. But instead, they dicided to hack compiz to shit to bend it to thier will. Really stupid when you consider all they had to do was bind the action in bug #689733 to THE OTHER KEYBINDING THAT WAS MEANT FOR THE TASK. Now The only reason I can see this isn't fixed is stubborn pigheadedness. Soon Suttleworth himself will be here to ironically tell us this is the way its supposed to be like it or lump it or fix it yourself.

I will never lift a finger for Ubuntu development again, I've seen this treatment too many times now. This attitude that the release is set in stone, fix it in the next one is just lazy.

zzecool (zzecool) wrote :

+1 for common sense

Sebastien Bacher (seb128) wrote :

hey everyone, thanks for the interest to Ubuntu/compiz/that issue and sorry it's taking time to get resolved but comments are turning to heated tone and insults at this point and that's often non constructive...

quite the contrary it might finish by demotivating the people who are on your side and want to see the issue fixed but are just overworked and didn't find the time to get to work on that yet

So could you move the chit-chat to some mailing list or user forum?

That said for those who want to help to get the issue resolved we welcome help on finding a solution which restore the option without changing the existing behaviour for users:

Summary of the issue/precise situation:

- super-W is binded to "show wins from all workspaces"
- "show for all workspaces" has been wrongly hacked to do "show only from current workspace"
- "show from current workspace" is not used

* the issue with undoing the hack is that it would change the behaviour of super-W for all existing user to work over all workspace when it's documented to be for the current workspace and how it behaves at the moment ...

* we can't "fix" those user configuration from the distribution side, the packages are not supposed to temper user configs and even if we could we have no garanty that the user directory is available (it could be password protected or on a nfs server and non mounted at the time of the upgrade)

@mniess did some suggestions in comment #136, thanks for that.

I don't think the "prompt user about the configuration" is something we wil do, that bug has 236 followers and some of you do care strongly about the topic, but in practice the question would be in-appropriate for 99% of Ubuntu users who don't care about that setting/don't use it/don't know about it/like it the way it is at the moment/don't want to be asked questions they don't understand on upgrade ... we believe that the tradeoff would be in disfavor of the majority of Ubuntu users, you might disagree but it's the calling we are making and we are discarting that option

That let us with the "add yet another option to "really show all wins for other workspaces included" or "find a better option that the ones suggested" ... we would really appreciate if somebody can help and come with a smart idea to solve the issue without breaking existing users or bothering them on upgrade

thanks for reading

Sebastien Bacher (seb128) wrote :

one other way would be to "break" "show wins from the current workspace" to make it show wins from all workspace, e.g have both actions reverse and not matching that description ... it's not "right" but it would make the action possible for the tweakers that want it without breaking behaviour on upgrade

Download full text (3.2 KiB)

Sebastian, how about switching the behaviours around for 12.04?

Maintain the current one as is and change the other to behave like this
did. Those who want to have the correct behaviour change the key bindings,
and current users are unaffected.

Does it make sense?
No dia 12 de Dez de 2012 17:48, "Sebastien Bacher" <email address hidden>
escreveu:

> hey everyone, thanks for the interest to Ubuntu/compiz/that issue and
> sorry it's taking time to get resolved but comments are turning to
> heated tone and insults at this point and that's often non
> constructive...
>
> quite the contrary it might finish by demotivating the people who are on
> your side and want to see the issue fixed but are just overworked and
> didn't find the time to get to work on that yet
>
> So could you move the chit-chat to some mailing list or user forum?
>
>
> That said for those who want to help to get the issue resolved we welcome
> help on finding a solution which restore the option without changing the
> existing behaviour for users:
>
> Summary of the issue/precise situation:
>
> - super-W is binded to "show wins from all workspaces"
> - "show for all workspaces" has been wrongly hacked to do "show only from
> current workspace"
> - "show from current workspace" is not used
>
> * the issue with undoing the hack is that it would change the behaviour
> of super-W for all existing user to work over all workspace when it's
> documented to be for the current workspace and how it behaves at the
> moment ...
>
> * we can't "fix" those user configuration from the distribution side,
> the packages are not supposed to temper user configs and even if we
> could we have no garanty that the user directory is available (it could
> be password protected or on a nfs server and non mounted at the time of
> the upgrade)
>
>
> @mniess did some suggestions in comment #136, thanks for that.
>
> I don't think the "prompt user about the configuration" is something we
> wil do, that bug has 236 followers and some of you do care strongly
> about the topic, but in practice the question would be in-appropriate
> for 99% of Ubuntu users who don't care about that setting/don't use
> it/don't know about it/like it the way it is at the moment/don't want to
> be asked questions they don't understand on upgrade ... we believe that
> the tradeoff would be in disfavor of the majority of Ubuntu users, you
> might disagree but it's the calling we are making and we are discarting
> that option
>
> That let us with the "add yet another option to "really show all wins
> for other workspaces included" or "find a better option that the ones
> suggested" ... we would really appreciate if somebody can help and come
> with a smart idea to solve the issue without breaking existing users or
> bothering them on upgrade
>
> thanks for reading
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/933776
>
> Title:
> [regression] scale/spread: "Initiate Window Picker for All Windows"
> does not show all windows. It shows only windows from curent
> workspace.
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/...

Read more...

@seb128: the problem goes much deeper than the "show all windows" thing. As far as I can see the offending commit is just reverted in 12.10 and the shortcuts are set correctly. This fixes everything (tm).

*Only* offering an option to show all windows will still leave all the other bugs that would be fixed by reverting the offending commit (flying windows, ...). Just as another incentive to really fix this instead of adding another hack to the first one that causes all the problems.

I don't know what feedback you get from corporate users (employees won't come here to report bugs) but I know several small businesses (50-150 employees) that suffer from this bug. We keep many users at 10.04 and the rest uses 12.10 (which we hate because it means a lot of extra work).

zzecool (zzecool) wrote :

I still can't understand .. seb

You say that if you are going to undo the "hack" the super-W would change the behaviour back to the "for all windows" when it is documented to be for the current workspace.

So while you undo the "hack" why don't you just change - fix the shortcut in the compiz config settings to correspond to the fix ? ( Assign super-W to initiate window picker ) So noone will notice the fix.

I really don't get it , it looks so dead simple.

Sebastien Bacher (seb128) wrote :

@mniess:

> This fixes everything (tm).

that would change the behaviour of super-W for users upgrading though no?

> will still leave all the other bugs that would be fixed by reverting the offending commit (flying windows, ...)

that's a different issue from the one this bug is about, this bug is ""Initiate Window Picker for All Windows" does not show all windows. It shows only windows from curent workspace.". There is no discussion that we should fix other bugs if they exist but:

- the number of comments "complaining" that things are broken make it hard to find where the informations are in the bug

- one bug report should describe one issue, that bug is about the picker acting on one workspace when it's supposed to include others ones. if you have other issues I would be happy to find resources in the desktop team to look at them and to help to get them resolved but please open a new bug with a short and explanatory description (better if users don't come to turn that one is a flood of comments as well so we can keep the discussion focussed on resolving that issue)

> I don't know what feedback you get from corporate users (employees won't come here to report bugs) but I know several small businesses (50-150 employees) that suffer from this bug.

We didn't get customers complains about that issue and nobody at Canonical has been complaining about it either.

Most people running unity just use the unity-launcher and click on the icons and get what they want, or they use the documented super-W which acts as documented.

In all the years I've been using GNOME/compiz or unity I never felt the need to use an "overview of all the wins open over all desktops" ... that would be a lot of things displayed and my workspaces are often organized by activity so the overview makes more sense to me when it's restricted to the workspace/context I'm working with. That's just to say that different people have different workflow and what might seem an end of the world issue is a no issue for others...

( note that I mention unity there because it's the desktop we ship and provide support for ... I do understand that some of you run compiz in other context though and that's fine and should work without bug as well)

In any case your users seem to have a workflow built around that feature and it would be good to fix the issue so let's focus on that

Sebastien Bacher (seb128) wrote :

@zzecool:

> So while you undo the "hack" why don't you just change - fix the shortcut in the compiz config settings to correspond to the fix ? ( Assign super-W to initiate window picker ) So noone will notice the fix.

you can find the reason in comment #158 I wrote a bit earlier, the configuration is user-owned and there is no way we can change user config behind that back for several reasons:

- the user config belongs to the user, it would feel wrong to change user settings behind their back, the package management tools don't touch user datas ...

- I'm sure you can understand some users would feel uneasy knowing that their datas might be changed by the system behind their back ... how to know which ones, what if something was set the way it was for a reason

- the user directory might not be accessible, it might be protected or unmounted

christian (chmathieu) wrote :

zzecool sayd:

-I still can't understand .. seb
-
-You say that if you are going to undo the "hack" the super-W would change the behaviour back to the "for all windows" when it is -documented to be for the current workspace.
-
-So while you undo the "hack" why don't you just change - fix the shortcut in the compiz config settings to correspond to the fix ? -( Assign super-W to initiate window picker ) So noone will notice the fix.
-
-I really don't get it , it looks so dead simple.

I say:: +1000

zzecool (zzecool) wrote :

Sorry Seb but your statement about the user data is not valid.

I know that in every compiz update i have to reassign all of my modifications in compiz config settings manager because every small compiz update reset them to the default.

Hot Corners Modified shortcuts etc .

Sebastien Bacher (seb128) wrote :

@zzecool: what you mention is a bug in compiz itself, it should not be happening and is being worked on...

Eddie Dunn (eddie-dunn) wrote :

The thing you seem to forget, Sebastien, is that the core issue is this:
A hack was introduced that not only changed the default behavior for all users, but -- more importantly -- also made it impossible to switch back to the desired behavior.

In other words, mucking around with people's configs has already been done. How about we own up to the mistake and fix it? The only reasonable way is to revert the ugly hack, and repair the functionality of 'show windows from all workspaces'. Users will have to update their key bindings if they don't like that it's working again. It won't take them more than a minute.

I can also add that I work in a corporate environment and everyone I know who uses Ubuntu here is -not- happy about the hack.

Doug McMahon (mc3man) wrote :

I guess I'm missing something here & as I don't use 12.04 should likely shut up
Anyway what's the downside to applying the 0.9.7 commit in precise & also adjusting scale.xml.in to get desired results.
Did so here on a 12.04 install still hanging around & when creating a new user the bindings & actions seemed fine
Super+w picks on current ws
Shift+Alt+up picks on all ws's

As in -
--- compiz-0.9.7.8+bzr3121.orig/plugins/scale/scale.xml.in
+++ compiz-0.9.7.8+bzr3121/plugins/scale/scale.xml.in
@@ -127,7 +127,7 @@
    <option name="initiate_key" type="key">
     <_short>Initiate Window Picker</_short>
     <_long>Layout and start transforming windows</_long>
- <default>&lt;Shift&gt;&lt;Alt&gt;Up</default>
+ <default>&lt;Super&gt;w</default>
    </option>
    <option name="initiate_button" type="button">
     <_short>Initiate Window Picker</_short>
@@ -145,7 +145,7 @@
    <option name="initiate_all_key" type="key">
     <_short>Initiate Window Picker For All Windows</_short>
     <_long>Layout and start transforming all windows</_long>
- <default>&lt;Super&gt;w</default>
+ <default>&lt;Shift&gt;&lt;Alt&gt;Up</default>
    </option>
    <option name="initiate_group_edge" type="edge">
     <_short>Initiate Window Picker For Window Group</_short>

@zzecool I think you are having another bug. My shortcuts settings has been
kept in every update, even with Bruno's great ppa (again many thanks Bruno,
you are awesome).

Matthias Niess (mniess) wrote :

@seb128: argh. I meant "this fixeD everything" (for 12.10 that is).

I know it's only one issue per bug report. But the underlying problem is a single commit and many bugs are connected to fixing this bug correctly (which has been done for 12.10). This bug produces issues for people who don't even use "scale all". Most corporte users don't use scale all but they do see the flying windows.

@mc3man: the problem fixing this bug is that if you fix it the default behavior changes and you can't change the user settings on upgrade. The only way to do that is ask for user interaction through a notification (the way it happens when you install Dropbox). That would work but bothering the user with notifications is unwanted, so it won't happen.

The way I see it this bug is unfixable with the only acceptable solution apparently being the introduction of a second hack that will (I think) introduce even more problems for the next dist-upgrade.

Actually, my fix that got merged (and I think reverted quickly after) removed the hack and introduced correct behavior, with the possibility of switching between the two behaviors. I wonder why it's not actually present in lp:compiz right now. We shouldn't be bothering with introducing different behavior at the beginning of a cycle, right?

I think I need to re-enter this bug and try finding a satisfactionary solution for everyone.

Sebastien Bacher (seb128) wrote :

@Doug:

> what's the downside to applying the 0.9.7 commit in precise & also adjusting scale.xml.in to get desired results.

changing default action will only apply for new user since the actions are written in the user's config on first start ... e.g your xml.in change will not apply to existing users and their super-W will start doing the wrong thing

@Matthias:

> I know it's only one issue per bug report. But the underlying problem is a single commit and many bugs are connected to fixing this bug correctly (which has been done for 12.10). This bug produces issues for people who don't even use "scale all". Most corporte users don't use scale all but they do see the flying windows.

Right, and I don't see an issue fixing "the flying windows bug" in a SRU, it seems like we could fix that while keeping the buggy action mapping to not change the super-W behaviour. It's likely that this bug would already have been fixed if there was a ticket tracking the "flying" issue rather than having it discussed in the middle for the 170 comments on the scale behaviour bug...

> The way I see it this bug is unfixable with the only acceptable solution apparently being the introduction of a second hack that will (I think) introduce even more problems for the next dist-upgrade.

we need to have a look on how the bug got fixed in 12.10 and if there is a side effect of making super-W do the wrong thing for upgrades or if that got dealt with in some way (note that this version migrated to gsettings so it gave an opportunity to migrate settings, we can't backport that though)

one other way would be to add some "migration code" to compiz itself, e.g have a one time migration, conditional to a flag that will be written somewhere, which could do something like "if scale for all workspace = super-W; then reset it and reset the "scale for one workspace"" so the new default are picked for users who didn't change the action.

Changed in compiz-core:
milestone: 0.9.7.12 → 0.9.7.14
Miklos Juhasz (mjuhasz) wrote :

> It's likely that this bug would already have been fixed if there was a ticket tracking the "flying" issue rather than having it discussed in the middle for the 170 comments on the scale behaviour bug...

There is one: LP: #955035

Sebastien Bacher (seb128) wrote :

> There is one: LP: #955035

great, let's use this one to track the flying windows issue then, the bug is in a reasonable state and a good basis for a SRU

Doug McMahon (mc3man) wrote :

Sebastien Bacher (seb128) wrote >
changing default action will only apply for new user since the actions are written in the user's config on first start ... e.g your xml.in change will not apply to existing users and their super-W will start doing the wrong thing

Not really, super+w is set for current workspace only & a patched compiz/.xml would continue to use super+w for current workspace only (tested here

The only possible issue with the current 0.9.7 commit + .xml change is the possibility of the so-called flying windows. As I mentioned quite some time ago over the course of 60 or so fresh 12.04 installs with a patched compiz the fly aways would sometimes happen only *once* per install, maybe others find differently??

Used the attached for reference

Sebastien Bacher (seb128) wrote :

@Doug: that requires testing, it seems weird that the system .xml value would take over the user config in the user .gconf directory (currently super-W is binding to "show wins on all workspaces" and that value is in the user config)

Doug McMahon (mc3man) wrote :

Probably best to do a new fresh install but maybe these to screens can illustrate -
this screen is with the current compiz source & bindings set to default values
(<super>w - all:, <Shift><Alt>Up - current WS, noting that *in use* Super+W picks from current WS irregardless of binding.

Doug McMahon (mc3man) wrote :

Now after installing patched compiz source the bindings are switched automatically
(probably a log out/in to take affect

@Bruno,
Unfortunately an update of compiz has replaced your ppa with Doug's patch. I don't want to bother you but it would be great if you update your ppa. Or better yet if you post a step by step guide how to compile compiz with Doug's patch.
Best regards.

Ethan Hogue (clappboard) on 2013-01-05
summary: [regression] scale/spread: "Initiate Window Picker for All Windows" does
- not show all windows. It shows only windows from curent workspace.
+ not show all windows. It shows only windows from current workspace.

Somehow I managed to broken my installation trying to compile compiz myself at my spare computer (then I installed 12.10 and scale is working now). But at my work computer I managed to pin bruno santos ppa this way:

# echo compiz-core hold | dpkg --set-selections
# echo compiz-plugins hold | dpkg --set-selections
# echo compiz hold | dpkg --set-selections

Colin Watson (cjwatson) on 2013-02-13
Changed in compiz (Ubuntu Precise):
milestone: ubuntu-12.04.2 → ubuntu-12.04.3

oh dear..

since Bruno's ppa (only sane solution so far, thanks bruno), was once again overwritten in January, I have been frustatedly waiting for 12.04.2..but since Colin's update it looks like it might be another 6 months...til 12.04.3

Does anyone know how to revert compiz to the version before it broke broke bruno's ppa and then pin it there?

Or can we buy bruno some beer to get him to update his ppa?...does he have an amazon wishlist or something?

or maybe this is one (the only) reason to upgrade to 12.10 or even 13.04?

@Oliver, you can install Synaptic to use a GUI to downgrade compiz and then run this commands (as root):

# echo compiz-core hold | dpkg --set-selections
# echo compiz-plugins hold | dpkg --set-selections
# echo compiz hold | dpkg --set-selections

Fuujuhi (fuujuhi) wrote :

Hello,

Been following this bug since 1 year now, hope there is still the intent to have it fixed in Precise. In any case, thanks already for the good work.

To add my 2-cent, what is the problem exactly of fixing compiz so that Super-W really does "Initiate Window Picker *For All Windows*", as it is shown in the compiz setting manager?

I understand that
- this would clean everything up (tmo, this is the most important), and
- would only affect users that use several workspaces
  - i.e. only a fraction of total user base, and
  - only such that to show more windows (not less, i.e. more functionality actually).

Fuujuhi (fuujuhi) wrote :

To answer my own question, I just had a look to https://bugs.launchpad.net/bugs/689733...

I think the following xkcd reference is obligatory:

http://xkcd.com/1172/

Looking forward to seeing the bug fix soon ;-)

Doug McMahon (mc3man) wrote :

Sebastien Bacher (seb128) wrote on 2012-12-13 >
@Doug: that requires testing, it seems weird that the system .xml value would take over the user config in the user .gconf directory (currently super-W is binding to "show wins on all workspaces" and that value is in the user config)

Don't know if anyone has tried/tested other than myself.
Tried again on both 12.04.1 & 12.04.2 installs, compiz (1:0.9.7.12-0ubuntu1) source, again see no issues. The scale fix to enable picking from all ws's works fine & patching the .xml patch sets new bindings as intended with already existing user after a log out/in.
super+w - current ws
shift+alt+up - all ws's

christian (chmathieu) wrote :

sorry, but "Initiate Window Picker for All Windows" does not work with me:

super + w -> current ws
shift + alt + up -> current ws

----------------------------------------------------------------
christian@d1561:~$ compiz --version
Compiz 0.9.7.12
christian@d1561:~$ unity --version
unity 5.18.0
----------------------------------------------------------------

Wujinnnnn (wujinnnnn) on 2013-02-21
Changed in ayatana-design:
assignee: nobody → Wujinnnnn (wujinnnnn)
msth67 (msth67) wrote :

Apart from "Initiate Window Picker For All Windows" being still broken to date,I would also point out that,once the plugin action (for a single window,obviously...) is initiated,the right-click (or button 3 ) click to exit the plugin doesn't work as it used to in previous compiz versions,which is kinda annoying and also IMHO inconsistent with the usual behavior,still found for instance in the Expo plugin.

I'm still having this problem on a fresh install of 13.04 64-bit.

MC Return (mc-return) wrote :

Hmm, "Initiate Window Picker For All Windows" works in trunk (which is Compiz 0.9.10-dev) and shows all windows from all workspaces...

@msth67: Please file a new bug about the right-click to exit issue -> I will fix it then.

On 6/1/2013 6:59 AM, Scott Kostyshak wrote:
> I'm still having this problem on a fresh install of 13.04 64-bit.
Scott - the *ability* to pick a window group from all Ws's has been
enabled But no default binding is being set in 13.04 & 13.10 in
scale.xml (.in)
So you'll need to set a binding yourself in
compizconfig-settings-manager (ccsm) > scale > bindings
Atm super+w is default for current Ws, suggested for all Ws's is
shift+alt+up though you can set as desired

(bindings for *both* could be default enabled as I previously mentioned
but at this point just take care of as a user...

Here it is working fine. Fresh 13.04

Doug McMahon (mc3man) wrote :

Until such time as it is fixed in 12.04 (if ever), put up a ppa to do so for precise
1. enables picking all windows from all workspaces
2. sets super+w for current ws, shift+alt+Up for all workspaces, does so for *both* new users & current user after a log out/in
https://launchpad.net/~mc3man/+archive/fixing-scale

christian (chmathieu) wrote :

Doug, I love you!
Precise is again the best. . . .

roots (roots) wrote :

Yes, Doug is the man.

Thanks A LOT for this fix !!!

Smeagol (gollum12345678) wrote :

Thanks Doug for the PPA, but saddly compiz crashed when I installed it. I had to go back to 1:0.9.7.12-0ubuntu1

Salem (salemsaberhagen) wrote :

Working flawless till now. Thanks Doug!
I already lost hope this will be ever fixed in Precise...

Chris (bridgeriver) wrote :

@Doug:

Working perfectly on my system (64-bit Precise) too. Many thanks.

Galvatron (megatron) wrote :

So far, Doug's fix works flawlessly, with no side effects (Precise 32-bit + xserver-xorg-lts-raring + 7300GT + Forceware 304.88).

msth67 (msth67) wrote :

This fix works perfectly in Mint 13 64 bit Mate edition,I can also set custom keyboard shortcuts in Compiz preferences to see windows from all workspaces,no issues-just a note,in my case logging in again via Mint's "new login" didn't do the trick,a full reboot was needed to have things working.

As for my comment #189 and reply #191,in reality I can't recall what was going wrong,after this fix now everything is working as expected,with button 3 zooming on the selected window-if anything,the scale addon that makes possible to "pull" a window to another workspace to the current one (when viewing windows from all workspaces) isn't working,but I don't know if that would be worth fixing.

Thanks a lot.

All hail mc3man, Doug's fix in comment #195 worked perfectly.
confirmed on Precise amd64

Alan Johnson (nilgiri) wrote :

I admit that I did not read every word in this comment history, but it seems the bug could be fixed in Precise without changing the default behavior. An updated package could fix the all-windows bug and set all the relevant default bindings to fire only the current-desktop-windows action. This would not change the default BEHAVIOR of the key bindings, or the user experience, but enable a user or admin to adjust the bindings to use the all-windows action if they like. One less PPA a corp, or even an individual, as to be weary of.

Apologies if I am missing something or just being redundant, but with all the noise in this thread it is very hard to follow.

Doug's fix works here too. Thanks! And thanks to all the contributors for all the hard work!

Javier Marino (marino-javier) wrote :

Doug McMahon (mc3man) you are the man, using yours ppa i was able to fix 2 of my biggest and frutrated bugs that i have. Seriusly thank you so much (hope to invited you a beer)

Cheers from Panama

tags: removed: ubuntu
Changed in compiz-core:
status: Triaged → Fix Released
To post a comment you must log in.